/*=================================*/
/* Pedigree structure definitions. */
/*=================================*/
#ifndef __HEADPED__
#define __HEADPED__

struct indlist { 
  struct ind *cur; 
  struct indlist *next; 
};

struct marlist {
  struct mar *cur; 
  struct marlist *next;
};

struct inddat {
  int name, sex, gen, degree;
  int flag, index;
  float xcoord, ycoord;
  unsigned char r,g,b;
  char *id;
  char *label;
};

struct ind { 
  struct ind *pa, *ma; 
  struct mar *par; 
  struct marlist *own; 
  struct inddat info;
};

struct mardat{
  int flag;
  float xcoord, ycoord;
};

struct mar{
  struct ind *pa, *ma;
  struct indlist *kids;
  struct mardat info;
};

#ifdef __cplusplus
extern "C" {
#endif

/*==================================================*/
/* External calls. See pedstacks.c for definitions. */
/*==================================================*/

  extern int maxind, maxmar, maxindlist, maxmarlist, maxlabel,
    indpt, marpt, indlistpt, marlistpt,
    higen, hilabel, ncomp, 
    coordset, genreset, pedset;
  
  extern struct ind **ped, *indstack, *noind;
  extern struct mar *marstack, *nomar;
  extern struct indlist *noindlist;
  extern struct marlist *nomarlist;
#ifdef __cplusplus
}
#endif

#endif
