#include "headio.h"
#include "Headped.H"
#include <string.h>
#include <malloc.h>
#define BIGNUM 5000

extern struct marlist *nextmarlist(void);
extern struct indlist *nextindlist(void);
extern int nextline(FILE *, char *);
extern void initpedc(int,int,int,int,int), initmardat(struct mardat *);
extern void initinddatc(struct inddat *), infect(struct mar *);

int inputpedc(FILE *infile, int ppk) 
{
  char line[maxline];
  char label[129]; char id[80]; char tmp[80];
  int nind, nmar, nindl, nmarl;
  int i, r, g, b, j, traits;
  int pa, ma, nm, par;
  struct indlist *il;
  struct marlist *ml;
  float xmax, ymax;
  traits = 0;
  xmax = ymax = 0.0f;
  nextline(infile,line);
  sscanf(line,"%s%s%s",label,tmp,id);

  if(ppk == 0){
    if(strcmp(label,"]pedc["))
      return 0;
  }
  else{
    if(tmp[0] != '=' && strcmp(id,"name"))
      return 0;
  }
  nextline(infile,line);sscanf(line,"%d",&nind);
  nextline(infile,line);sscanf(line,"%d",&nmar);
  nextline(infile,line);sscanf(line,"%d",&nindl);
  nextline(infile,line);sscanf(line,"%d",&nmarl);
  nextline(infile,line);sscanf(line,"%d",&hilabel);
  nextline(infile,line);sscanf(line,"%d",&ncomp);
  nextline(infile,line);sscanf(line,"%d",&coordset);
  nextline(infile,line);
  nextline(infile,line);sscanf(line,"%d",&genreset);
  nextline(infile,line);sscanf(line,"%d",&higen);
  nextline(infile,line);
  if(ppk) sscanf(line,"%d",&traits);
  initpedc(nind,nmar,nindl,nmarl,hilabel);

  /* throw away trait information */
  for(i=0; i<traits; i++) nextline(infile,line);

  /* Get marriages */
  for (i=1; i<=nmar; i++){
    initmardat(&(marstack[i].info));
    nextline(infile,line);
    sscanf(line,"%d%d%f%f", 
	   &pa, &ma,
	   &marstack[i].info.xcoord,
	   &marstack[i].info.ycoord);
    marstack[i].pa = &indstack[pa];
    marstack[i].ma = &indstack[ma];
    if(marstack[i].info.xcoord > xmax) xmax = marstack[i].info.xcoord;
    if(marstack[i].info.ycoord > ymax) ymax = marstack[i].info.ycoord;
    ml = nextmarlist();
    ml->cur = &marstack[i];
    ml->next = indstack[pa].own;
    indstack[pa].own = ml;
    ml = nextmarlist();
    ml->cur = &marstack[i];
    ml->next = indstack[ma].own;
    indstack[ma].own = ml;
  } 
  if(xmax >= 1.0f){
    xmax *= 1.01f;
    for (i=1; i<=nmar; i++) marstack[i].info.xcoord /= xmax;
  }
  if(ymax >= 1.0f){
    ymax *= 1.01f;
    for (i=1; i<=nmar; i++) marstack[i].info.ycoord /= ymax;
  }
  
  /* Get individuals */
  xmax = ymax = 0.0f;
  for (j=0,i=1; i<=nind; i++){
    initinddatc(&(indstack[i].info));
    nextline(infile,line);
    label[0] = 0; id[0] = 0;
    sscanf(line,"%d%d%d%d%d%f%f%d%d%d%s%128[^\n]",
	   &nm, &par,
	   &indstack[i].info.sex,
	   &indstack[i].info.gen,
	   &indstack[i].info.degree,
	   &indstack[i].info.xcoord,
	   &indstack[i].info.ycoord,
	   &r, &g, &b,id,label);
    if(indstack[i].info.ycoord > ymax) ymax = indstack[i].info.ycoord;
    if(indstack[i].info.xcoord > xmax) xmax = indstack[i].info.xcoord;

    if(ppk){
      r = 200; g = 220; b = 240;
    }    
    else
      for(j = 0; label[j] == ' '; j++);
    indstack[i].info.r = r;
    indstack[i].info.g = g;
    indstack[i].info.b = b;

    if(ppk || label[j]==0){
      indstack[i].info.label=(char *) malloc(1);
      indstack[i].info.label[0]=0;
    }else{
      indstack[i].info.label=(char *) malloc(strlen(label)+1);
      strcpy(indstack[i].info.label,&label[j]);
    }
    if(ppk || id[0]==0){
      indstack[i].info.id=(char *) malloc(1);
      indstack[i].info.id[0]=0;
    }else{
      indstack[i].info.id=(char *) malloc(strlen(id)+1);
      strcpy(indstack[i].info.id,id);
    }
    ped[nm] = &indstack[i];
    indstack[i].info.name = nm;
    indstack[i].par = &marstack[par];
    indstack[i].pa = marstack[par].pa;
    indstack[i].ma = marstack[par].ma;
    if ( par ){
      il = nextindlist();
      il->cur = &indstack[i];
      il->next = marstack[par].kids;
      marstack[par].kids = il;
    }
  }
  if(xmax >= 1.0f){
    xmax *= 1.01;
    for (i=1; i<=nind; i++) indstack[i].info.xcoord /= xmax;
  }
  if(ymax >= 1.0f){
    ymax *= 1.01;
    for (i=1; i<=nind; i++) indstack[i].info.ycoord /= ymax;
  }

  indpt = nind;
  marpt = nmar;
  if (!ncomp){
    ncomp = 0;
    for (i = 1; i <= marpt; i++) marstack[i].info.flag = DOWN;
    for (i = 1; i <= marpt; i++) 
      if (marstack[i].info.flag == DOWN) {infect(&marstack[i]); ncomp += 1;}
  }
  return 1+traits;
}
