#include "headio.h"
#include "Headped.H"

void outputpedc(FILE *outfile, char pedname[], int ppk){
  int nind, nmar, nil, nml, hl, ng, dg;
  int i;
  int par, pa, ma;
  struct marlist *ml;
  struct indlist *il;

  for  (nind=0, i=1, hl=0, nml=0, ng=0; i<=indpt; i++){
    if (indstack[i].info.flag != DOWN){
      nind++;
      indstack[i].info.flag = nind;
      if (hl < indstack[i].info.name) hl = indstack[i].info.name;
      if (ng < indstack[i].info.gen) ng = indstack[i].info.gen;
      for (ml = indstack[i].own; ml != nomarlist; ml = ml->next)
	if (ml->cur->info.flag != DOWN) nml++;
    }
  }

  for (nmar=0, i=1, nil=0; i<=marpt; i++){
    if (marstack[i].info.flag != DOWN){
      nmar++;
      marstack[i].info.flag = nmar;
      for (il=marstack[i].kids; il != noindlist; il = il->next)
	if (il->cur->info.flag != DOWN) nil++;
    }
  }
  if(ppk)
    fprintf(outfile,"%s = name",pedname);
  else
    fprintf(outfile,"]pedc[ %s",pedname);
  fprintf(outfile,"\n%5d = # individuals",nind);
  fprintf(outfile,"\n%5d = # marriages",nmar);
  fprintf(outfile,"\n%5d = # ind lists",nil);
  fprintf(outfile,"\n%5d = # mar lists",nml);
  fprintf(outfile,"\n%5d = highest label",hl);
  fprintf(outfile,"\n%5d = # components",ncomp);
  fprintf(outfile,"\n%5d = coordinates set",coordset);
  fprintf(outfile,"\n%5d = %s ",0,ppk ? "inbreding set" : "not used");
  fprintf(outfile,"\n%5d = generations reset",genreset);
  fprintf(outfile,"\n%5d = highest generation",ng);

/* Need to handle genetic data */
  fprintf(outfile,"\n%5d = %s ",0,ppk ? "# traits set" : "not used");
 
  fprintf(outfile,"\n.Marriages");
  fprintf(outfile,"\n.%4s%5s%7s%7s","pa","ma","xcoord","ycoord");
  for (i=1; i<=marpt; i++){
    if (marstack[i].info.flag != DOWN){
      pa = marstack[i].pa->info.flag;
      ma = marstack[i].ma->info.flag;
      fprintf(outfile,"\n %4d %4d %6.4f %6.4f",
	      pa,ma,marstack[i].info.xcoord,marstack[i].info.ycoord);
    }
  }
  
  fprintf(outfile,"\n.Individuals");
  fprintf(outfile,"\n. idx  par sx gn dg xcoord ycoord");
  if(ppk)
    fprintf(outfile,"  inbreeding Traits");
  else
    fprintf(outfile,"   r   g   b     id  label");
  for (i=1; i<=indpt; i++){
    if (indstack[i].info.flag != DOWN){
      par = 0;
      dg = 0;
      if (indstack[i].par != nomar && indstack[i].par->info.flag != DOWN){
	dg = 1;
	par = indstack[i].par->info.flag;
      }
      for (ml = indstack[i].own; ml!=nomarlist; ml=ml->next)
	if (ml->cur->info.flag != DOWN) dg++;
      fprintf(outfile,"\n %4d %4d %2d %2d %2d",
	      indstack[i].info.name,par,indstack[i].info.sex,
	      indstack[i].info.gen,dg);
      fprintf(outfile," %6.4f %6.4f",
	      indstack[i].info.xcoord,indstack[i].info.ycoord);
      if(ppk)
	fprintf(outfile," -1.0000e+00");
      else
	fprintf(outfile," %3d %3d %3d %s %s",
		indstack[i].info.r,
		indstack[i].info.g,indstack[i].info.b,indstack[i].info.id,
		indstack[i].info.label);
    }
  }
  fprintf(outfile,"\n");
  for (i=1; i<=indpt; i++)
    if (indstack[i].info.flag != DOWN) indstack[i].info.flag = UP;
  for (i=1; i<=marpt; i++)
    if (marstack[i].info.flag != DOWN) marstack[i].info.flag = UP;
}
