#include "pfiddbas.h"
#include "pfiddler.h"
#include <FL/Fl_Color_Chooser.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Input.H>
#include <sstream>
#include<cstring>

float xscale=1, yscale=1;
ind *currInd=NULL;
mar *currMar=NULL;
int rowmov = 1;

extern Fl_Input *nme;
extern Fl_Input *indx;
extern Fl_Input *lbl;


void cb_label(Fl_Widget *co){
  strcpy(currInd->info.label,((Fl_Input *)co)->value());
}

void Drawing::draw(){
    xscale=(float)w();
    yscale=(float)h()-20;
    if(pedcopen) 
      drawped();
}

float __xx(int x){
  float tmp = x/xscale;
  return tmp;
}

float __yy(int y){
  float tmp = 1.0- y/yscale;
  return tmp;
}

int check_point(int x, int y){
  float xx = x/ xscale;
  float yy = 1.0 - (y-20)/yscale;

  std::ostringstream foo;
  if( (currInd = closestind(xx,yy)) ){
    nme->value(currInd->info.id);
    nme->deactivate();
    foo << currInd->info.name << std::ends;
    indx->value((foo.str()).c_str());
    indx->deactivate();
    lbl->value(currInd->info.label);
    lbl->activate();
  }else if((currMar=closestmar(xx,yy))){
    foo << currMar->pa->info.name << " x " 
	<<currMar->ma->info.name <<std::ends;
    nme->value((foo.str()).c_str());
    nme->deactivate();
    indx->value("node");
    indx->deactivate();
    lbl->value("");
    lbl->deactivate();
  }else{
    if(pedcopen){
      nme->value("");
      nme->activate();
      indx->value("");
      indx->activate();
    }
    lbl->value("");
    lbl->deactivate();
    flag_cb = 0;
    return 0;
  }
  return 1;
}


int Drawing::handle(int event){
  static int ix;
  static int iy;
  static int button = 0;
  float xx, yy;
  switch(event){
  case FL_ENTER:
    show();
    redraw();
    if(flag_cb){
      if(flag_cb <4) fl_cursor((Fl_Cursor)45);
      else fl_cursor(FL_CURSOR_CROSS);
    }
    return 1;
  case FL_MOVE:
    if(!flag_cb){
      if(check_point(Fl::event_x(), Fl::event_y()))
	fl_cursor((Fl_Cursor)31);
      else fl_cursor(FL_CURSOR_DEFAULT);
    }else{
      if(flag_cb <4) fl_cursor((Fl_Cursor)45);
      else fl_cursor(FL_CURSOR_CROSS);
    }
    break;
  case FL_PUSH:
    show();
    redraw();
    ix = Fl::event_x();
    iy = Fl::event_y();
    button = Fl::event_button();
    switch(button){
    case 1:  // mouse button 1
      if (check_point(ix, iy)){
	switch(flag_cb){
	case 1:
	  if(currInd){
	    if(currInd->par != nomar && currInd->par->info.flag != GONE)
	      currMar = currInd->par;
	    else{
	      struct marlist *ml;
	      for(ml=currInd->own; ml != nomarlist; ml = ml->next)
		if(ml->cur->info.flag != GONE){
		  currMar = ml->cur;
		  break;
		}
	    }
	  }
	  if(currMar) zapfam(currMar);
	  break;
	case 2:
	  if(currInd){
	    remove(currInd);
	  }
	  break;
	case 3:
	  if(currMar){
	    drawmar(currMar, FL_GRAY);
	    currMar->info.flag = GONE;
	  }
	  break;
	case 4:
	  if(currInd)
	    dropdowncolor(currInd);
	  break;      
	case 5:
	  if(currInd)
	    dropupcolor(currInd);
	  break;
	case 6:
	  if(currInd)
	    ordowncolor(currInd);
	  break;      
	case 7:
	  if(currInd)
	    orupcolor(currInd);
	  break;
	case 8:
	  if(currInd)
	    anddowncolor(currInd);
	  break;      
	case 9:
	  if(currInd)
	    andupcolor(currInd);
	  break;
	case 10:
	  if(currInd)
	    hidecolor(currInd);
	  break;
	default:
	  if(rowmov == 3) {
	    if(currInd) 
	      move(currInd,__xx(ix),roundind(currInd->info.ycoord));
	    else
	      move(currMar,__xx(ix),roundmar(currMar->info.ycoord));
	  }
	  fl_cursor(FL_CURSOR_MOVE);
	  break;
	}
	if(flag_cb) button = 0;
	return 1;
      }
      break;
    case 2:
      if(check_point(ix,iy)){
	fl_cursor((Fl_Cursor)19);
	return 1;
      }
      return 0;
    case 3:   // mouse button 3
      if(check_point(ix, iy)  && currInd){
	fl_color_chooser("Select color",
			 currInd->info.r,
			 currInd->info.g,
			 currInd->info.b);
	return 1;
      }
      break;
    }
    return 0;
  case FL_DRAG:
    xx = __xx(Fl::event_x());
    yy = __yy(Fl::event_y());
    switch (button){
    case 1:
      switch(rowmov){
      case 0:
	if(currInd)
	  move(currInd,xx,yy);
	else
	  move(currMar,xx,yy);
	break;
      case 1:
	  if(currInd)  
	    move(currInd,xx,currInd->info.ycoord);
	  else
	    move(currMar,xx,currMar->info.ycoord);
	  break;
      case 2:
	if(currInd)  
	  move(currInd,currInd->info.xcoord,yy);
	else
	  move(currMar,currMar->info.xcoord,yy);
	break;
      case 3:
	if(currInd) 
	  move(currInd,xx,roundind(yy));
	else
	  move(currMar,xx,roundmar(yy));
	break;
      }
      break;
    case 2:
      if(currInd)
	moveprole(currInd,xx,yy);
      else
        moveprole(currMar,xx,yy);
      break;
    default:
      return 0;
    }
    show();
    redraw();
    return 1;
  case  FL_RELEASE:
    fl_cursor(FL_CURSOR_DEFAULT);
    return 1;
  }
  return 0;
}

int _x(float x){ 
  return (int)(x*xscale+0.5); 
}

int _y(float y){ 
  return (int)((1.0-y)*yscale+0.5) + 20; 
}

void drawline(float x0, float y0, float x1, float y1, Fl_Color color)
{
  fl_color(color);
  fl_line(_x(x0),_y(y0),_x(x1),_y(y1));
}


void drawsquare(float x,float y, Fl_Color color, Fl_Color line)
{
  fl_color(color);
  fl_rectf(_x(x)-5,_y(y)-5,10,10);
  fl_color(line);
  fl_rect(_x(x)-5,_y(y)-5,10,10);
}

void drawsquare(float x,float y, uchar  r, uchar g, uchar b, Fl_Color line)
{
  fl_color(r, g, b);
  fl_rectf(_x(x)-5,_y(y)-5,10,10);
  fl_color(line);
  fl_rect(_x(x)-5,_y(y)-5,10,10);
}

void drawcircle(float x,float y, Fl_Color color, Fl_Color line)
{
  fl_color(color);
  fl_pie(_x(x)-5,_y(y)-5,11,11,0,360);
  fl_color(line);
  fl_arc(_x(x)-5,_y(y)-5,11,11,0,360);
}

void drawcircle(float x,float y, uchar r, uchar g, uchar b, Fl_Color line)
{
  fl_color(r, g, b);
  fl_pie(_x(x)-5,_y(y)-5,11,11,0,360);
  fl_color(line);
  fl_arc(_x(x)-5,_y(y)-5,11,11,0,360);
}

void drawdiamon(float x,float y, Fl_Color color, Fl_Color line)
{
  fl_color(color);
  int x0=_x(x);
  int y0=_y(y);
  fl_polygon(x0,y0-7,x0+7,y0,x0,y0+7,x0-7,y0);
  fl_color(line);
  fl_loop(x0,y0-7,x0+7,y0,x0,y0+7,x0-7,y0);
}

void drawdiamon(float x,float y, uchar r, uchar g, uchar b, Fl_Color line)
{
  fl_color(r, g, b);
  int x0=_x(x);
  int y0=_y(y);
  fl_polygon(x0,y0-7,x0+7,y0,x0,y0+7,x0-7,y0);
  fl_color(line);
  fl_loop(x0,y0-7,x0+7,y0,x0,y0+7,x0-7,y0);
}


void erasesquare(float x,float y, Fl_Color color)
{
  fl_color(color);
  fl_rectf(_x(x)-6,_y(y)-6,12,12);
}

void erasecircle(float x,float y, Fl_Color color)
{
  fl_color(color);
  fl_pie(_x(x)-7,_y(y)-7,13,13,0,360);
}

void erasediamon(float x,float y, Fl_Color color)
{
  fl_color(color);
  int x0=_x(x);
  int y0=_y(y);
  fl_polygon(x0-1,y0-8,x0+8,y0,x0,y0+8,x0-8,y0);
}
