/*=========================================*/
/* Header file for PostScript draw routine */
/*=========================================*/
#ifndef __POSTSCRIPT_H__
#define __POSTSCRIPT_H__

#include "headio.h"
#define SQRT_2  0.707107
#define SQRTPI  1.772454

#define PAGEWIDTH          8.5
#define PAGEHEIGHT        11.0

#define UNITSPERPOINT          10
#define UNITSPERINCH           72 * UNITSPERPOINT
#define DEFAULTMARGIN         0.5
#define DEFAULTLINEWIDTH      0.5   /* in points */
#define DEFAULT_TITLE_PTSIZE  18.   /* in points */
#define DEFAULT_LABEL_PTSIZE   9.   /* in points */
#define DEFAULT_ICON_SIZE      9.   /* in points */
#define DEFAULT_ELBOW_ROOM     0.   /* in points */
#define TITLESEP              1.0   /* fraction of title point size */
#define TICLEN               0.01   /* fraction of plot size */
#define DEFAULTINSIDE        0.04   /* fraction of plot size */
                                    /* -- room between box and plot */
#define LABELSEP             0.40   /* fraction of label point size */
#define TWICE_MIN_DOT_SIZE   30.0   /* multiple of line width */

#define NO                   0
#define YES                  1

#ifdef __cplusplus
struct Plotparm{
#else
typedef struct _plotparm{
#endif 
  int frame, ids, icons, labels, rotate, media, graphtype ; 
  float height, width, linewidth, margins, title_ptsize,
    label_ptsize, icon_size, elbow_room, extra_margin;
  char title[maxstr];
#ifdef __cplusplus
};
#include <fstream>
void drawps(std::ofstream &,const char *, const Plotparm &);
void drawps(const char *, const Plotparm &);
#else
} Plotparm;
void drawps(FILE *, char *, Plotparm);
#endif
#endif
