#include <cstdlib>
#include <cstring>
#include <ctime>
#include <fstream>
#include <iostream>
#include <iomanip>
#ifndef WIN32
 #include <pwd.h>
#endif
#include <unistd.h>
#include "Headped.H"
#include "util.h"
#include "postscript.h"
#include "headio.h"

#include "simanneal.h"

using namespace std;

void psheader(const char *creator, const int llx,
	      const int lly, const int urx, const int ury, const
	      Plotparm &p){
  int dsze, csze, ssze, asze, lwd, bbf, medX, medY;
  time_t clock = time((time_t *) NULL);
  float cex;
  char *username;
  char medN[28];

#ifndef WIN32
  username = getlogin();
  if ( username == NULL ) username = getpwuid(getuid())->pw_name;
#else
  username = "Windows";
#endif

  csze = (int) (UNITSPERPOINT * p.icon_size / SQRTPI);
  ssze = (int) (UNITSPERPOINT * p.icon_size);
  asze = (int) (UNITSPERPOINT * p.icon_size * SQRT_2);
  dsze = (int) MAXIMUM( TWICE_MIN_DOT_SIZE * p.linewidth,
			csze * p.linewidth * 0.75 );
		      
  cex  = p.label_ptsize / 14.0;
  lwd  = (int) ( 40.0 * cex );

  medX = medY = 0;
  switch(p.media){
  case 1: 
    strcpy(medN,"Letter"); medX=612; medY= 792; break;
  case 2:
    strcpy(medN,"A4"); medX= 595; medY= 842; break;
  case 3:
    strcpy(medN,"Legal"); medX= 612; medY= 1008; break;
  case 4:
    strcpy(medN,"Statement"); medX= 396; medY= 612; break;
  case 5:
    strcpy(medN,"Tabloid"); medX= 792; medY= 1224; break;
  case 6:
    strcpy(medN,"Ledger"); medX= 1224; medY= 792; break;
  case 7:
    strcpy(medN,"Folio"); medX=612; medY= 936; break;
  case 8:
    strcpy(medN,"Quarto"); medX= 610; medY= 780; break;
  case 9:
    strcpy(medN,"10x14"); medX= 720; medY= 1008; break;
  }

  cout << "%!PS-Adobe-3.0";
  if(p.media) cout << endl;
  else cout << " EPSF-3.0" << endl;
  cout << "%%DocumentNeededResources: fonts Helvetica\n"
      << "%%DocumentFonts: Helvetica\n";
  if ( p.title[0] == '\0' )
    cout << "%%Title: (none)\n";
  else
    cout << "%%Title: " <<  p.title << endl;
  cout << "%%Creator: " << creator << endl
      << "%%CreationDate: " <<  ctime(&clock)
      << "%%For: " << username << endl
      << "%%DocumentData: Clean7Bit" << endl;
  if(p.media)
    cout << "%%DocumentMedia: " << medN << ' ' << medX << ' ' << medY 
	<< " 75 ( ) ( )\n"
	<<  "%%Pages: 1\n";
  bbf =  p.frame  ?  (int)(3+p.linewidth) : 0 ;
  if(((int) (llx / 10.0)) < bbf || ((int) (lly / 10.0)) < bbf) bbf = 0; 
  cout << "%%BoundingBox: "
      << (int) (llx / 10.0) - bbf << ' ' << (int) (lly / 10.0)-bbf << ' '
      << (int) ((p.rotate ? ury : urx) / 10.0)+bbf << ' '
      << (int) ((p.rotate ? urx :ury) / 10.0)+bbf << endl
      << "%%EndComments\n"
      << "%%BeginProlog: procset Pedfiddler_proc\n"
      << "/Pedfiddler_proc 100 dict def\n"
      << "Pedfiddler_proc begin\n"
      << "/bd {bind def} def\n"
      << "/M {moveto} bd\n"
      << "/L {lineto} bd\n"
      << "/R {rlineto} bd\n"
      << "/C {closepath} bd\n"
      << "/N {newpath} def\n"
      << "/Sk {stroke} def\n"  
      << "/GS {gsave} def\n"
      << "/GR {grestore} def\n"
      << "/SGF {setgray fill} bd\n"
      << "/tex {\n"
      << "  GS\n"
      << "  M 0 index\n"
      << "  dup stringwidth pop neg 2 div 0 rmoveto\n"
      << "  GS\n  false charpath\n  1 setgray " <<lwd << " setlinewidth\n"
      << "  1 setlinejoin Sk GR\n"
      << "  show GR\n"
      << "  } bd\n"
      << "/edge {\n  M L\n} bd\n"
      << "/dot {\n"
      << "  GS N " << dsze <<" 0 360 arc 0 SGF GR\n"
      << "  } bd\n"
      << "/cir {\n"
      << "  N " << csze << " 0 360 arc\n"
      << "  GS setrgbcolor fill GR Sk\n"
      << "  } bd\n"
      << "/squ {\n"
      << "  N M\n"
      << "  0 " << ssze << " R " << ssze << " 0 R\n"
      << "  0 " << -ssze << " R " << -ssze << " 0 R\n"
      << "  C\n"
      << "  GS setrgbcolor fill GR Sk\n"
      << "  } bd\n"
      << "/dia {\n"
      << "  N M\n"
      << "  " << -asze << ' ' << asze << " R " << asze
      << ' ' << asze <<" R\n"
      << "  " << asze << ' ' << -asze << " R " << -asze 
      << ' ' <<-asze <<" R\n"
      << "  C\n"
      << "  GS setrgbcolor fill GR Sk\n"
      << "  } bd\n"
      << "end\n"
      << "%%EndProlog\n"
      << "%%BeginSetup" << endl;
  if(p.media){
    cout << "%%BeginFeature: *PageSize: " << medN << endl
	<< "  << /PageSize [" << medX << ' ' << medY 
	<< "] /ImagingBBox null >> setpagedevice\n"
	<< "%%EndFeature" << endl;
  }
  cout << "Pedfiddler_proc begin\n"
      << "gsave\n"
      << "%%EndSetup\n"
      << "%%Page: 1 1\n"
      << (int) (UNITSPERPOINT * p.linewidth) << " setlinewidth\n"
      << "0.1 0.1 scale\n"
      << "1 setlinecap 1 setlinejoin\n"
      << "0 setgray\n"
      << "%%IncludeResource: font Helvetica\n"
      << "/Helvetica findfont " << (int)(140*cex) 
      << " scalefont setfont" << endl;
  if(p.rotate)
    {
      cout << (int)(p.width * UNITSPERINCH) << " 0 translate 90 rotate"
	  << endl;
    }
}

void rescalex(float delta){
  int **idx, *idxbuf;
  int i, j, k, left, gen, *ngen, keyindex, offset;
  float ycoord, lastycoord, keycoord;
  int jj;
  int **pools, *poolsbuf, *npools;
  float maxxcoord, minxcoord, xdelta, xstart;
  float **poolsum, *poolsumbuf;

  ngen = new int[indpt];

  for(k=0,i=2; i<=indpt; i++){
    for(j=1; j<i; j++)
      if(indstack[j].info.ycoord == indstack[i].info.ycoord){
	k++;
	break;
      }
  }
  gen = indpt - k;
  idx = new int*[gen];
  idxbuf = new int[indpt];
  lastycoord = - 10000.0;
  left = indpt;
  j = 0;

  while(left > 0){
    idx[j] = idxbuf + indpt - left;
    ycoord = 10000.0;
    for (i = 1; i<=indpt; i++)
      if(indstack[i].info.ycoord > lastycoord && \
	 indstack[i].info.ycoord < ycoord )
	ycoord = indstack[i].info.ycoord;
    ngen[j] = 0;
    for(i = 1; i<=indpt; i++)
      if(indstack[i].info.ycoord == ycoord ){
	idx[j][ngen[j]++] = i;
	left--;
      }
    j++;
    lastycoord = ycoord;
  }
  /* sort generations */
  for(i=0; i<gen; i++){
    for(j=0; j<ngen[i]-1; j++){
      keyindex = idx[i][j];
      keycoord = indstack[keyindex].info.xcoord;
      for(k=j+1; k<ngen[i]; k++)
	if(keycoord > indstack[idx[i][k]].info.xcoord){
	  keyindex = idx[i][k];
	  keycoord = indstack[keyindex].info.xcoord;
	  idx[i][k] = idx[i][j];
	  idx[i][j] = keyindex;
	}
      idx[i][j] = keyindex;
    }
  }

  npools = new int[gen];
  pools = new int*[gen];
  poolsbuf = new int[indpt];

  offset = 0;
  for ( i=0; i<gen; i++ ){
    pools[i] = poolsbuf + offset;
    offset += ngen[i];
  }

  poolsum = new float*[gen];
  poolsumbuf = new float[indpt];

  offset = 0;
  for(i=0; i<gen; i++){
    poolsum[i] = poolsumbuf + offset;
    offset += ngen[i];
  }

  minxcoord = 10000.0; maxxcoord = - 10000.0;
  for(i = 1; i<=indpt; i++){
    if(indstack[i].info.xcoord > maxxcoord)
      maxxcoord = indstack[i].info.xcoord;
    if(indstack[i].info.xcoord < minxcoord)
      minxcoord = indstack[i].info.xcoord;
  }

  if(maxxcoord - minxcoord > 0)
    xdelta = delta * ( maxxcoord - minxcoord );
  else
    xdelta = 1;

  for(i=0; i<gen; i++){
    npools[i] = 0;
    for (j=0; j<ngen[i]; j++){
      npools[i]++;
      pools[i][npools[i]-1] = 1;
      poolsum[i][npools[i]-1] = indstack[idx[i][j]].info.xcoord;
      while(npools[i] > 1 && \
	    ((poolsum[i][npools[i]-2] / pools[i][npools[i]-2]) + \
	     (pools[i][npools[i]-2] + pools[i][npools[i]-1] ) * xdelta * 0.5 \
	     > ( poolsum[i][npools[i]-1] / pools[i][npools[i]-1]))){
	npools[i]--;
	pools[i][npools[i]-1] += pools[i][npools[i]];
	poolsum[i][npools[i]-1] += poolsum[i][npools[i]];
      }
    }
  }

  for(i=0; i<gen; i++){
    j = 0;
    for ( jj=0; jj<npools[i]; jj++ ){
      xstart = poolsum[i][jj] / pools[i][jj] - ( pools[i][jj] - 1 ) \
	*  xdelta * 0.5;
      if ( pools[i][jj] > 1 )
	for ( k=0; k<pools[i][jj]; k++ )
	  indstack[idx[i][j++]].info.xcoord = xstart + k * xdelta;
      else
	j++;
    }
  }
  delete [] ngen;
  delete [] idx;
  delete [] idxbuf;
  delete [] npools;
  delete [] pools;
  delete [] poolsbuf;
  delete [] poolsum;
  delete [] poolsumbuf;
  balancemariages();
}

#define MIN(A,B) ( (A) < (B) ? (A) : (B) )

int llx, lly, urx, ury, buy, bly, plx, prx, ply, puy, titleroom;

/* BoundingBox is llx (lower left x coord)
   lly (lower left y coord)
   urx (upper left x coord)
   ury (upper left y coord)

   bly = lly : y coord of lower edge of box
   buy       : y coord of upper edge of box

   plx : minimum x coord of individual or marriage
   prx : maximum x coord of individual or marriage
   ply : minimum y coord of individual or marriage
   puy : maximum y coord of individual or marriage
*/

float minxcoord, maxxcoord, minycoord, maxycoord;
int tic_length;
void openplot(const char *creator, const Plotparm &p){
  int margin;
  int onespace, otherspace;
  int i;

  if ( p.title[0] == 0 )
    titleroom = 0;
  else
    titleroom = (int) ( UNITSPERPOINT * p.title_ptsize * ( 1.0 + TITLESEP ) );

  margin = (int) ( UNITSPERINCH * p.margins );
  llx = margin;
  lly = margin;
  bly = lly;
  urx = (int) ( UNITSPERINCH * (p.rotate ? p.height : p.width)) - margin;
  ury = (int) ( UNITSPERINCH * (p.rotate ? p.width : p.height)) - margin;
  buy = ury - titleroom;
  psheader(creator, llx, lly, urx, ury, p);

  if(p.title[0] != 0 ){
    cout << "gsave\n" << setprecision(4)
	<< "currentfont " << p.title_ptsize / p.label_ptsize
	<< " scalefont setfont\n"
	<< '(' << p.title << ") dup stringwidth pop 2.0 div "
	<< llx + ( urx - llx ) / 2 << " sub neg "
	<<buy + titleroom / 2 << " moveto show\n"
	<< "grestore" << endl;
  }

  minxcoord = 10000.0; maxxcoord = - 10000.0;
  minycoord = 10000.0; maxycoord = - 10000.0;
  for ( i = 1; i<=indpt; i++)
    {
      if ( indstack[i].info.xcoord > maxxcoord )
	maxxcoord = indstack[i].info.xcoord;
      if ( indstack[i].info.xcoord < minxcoord )
	minxcoord = indstack[i].info.xcoord;
      if ( indstack[i].info.ycoord > maxycoord )
	maxycoord = indstack[i].info.ycoord;
      if ( indstack[i].info.ycoord < minycoord )
	minycoord = indstack[i].info.ycoord;
    }
  for (i=1; i<=marpt; i++)
    {
      if ( marstack[i].info.xcoord > maxxcoord )
	maxxcoord = marstack[i].info.xcoord;
      if ( marstack[i].info.xcoord < minxcoord )
	minxcoord = marstack[i].info.xcoord;
      if ( marstack[i].info.ycoord > maxycoord )
	maxycoord = marstack[i].info.ycoord;
      if ( marstack[i].info.ycoord < minycoord )
	minycoord = marstack[i].info.ycoord;
    }

  tic_length = (int) ( TICLEN * MIN( urx - llx, buy - bly ) );
  /* onespace is the space from either side to any individual or marriage */
  onespace = (int)(p.icon_size/SQRTPI * UNITSPERPOINT / 2 + \
		   DEFAULTINSIDE * MIN( urx - llx, buy - bly ));
  /* onespace + otherspace it the space form the top or bottom to 
     any individual or marriage */
  otherspace = (int)((1.50 + LABELSEP) * p.label_ptsize * UNITSPERPOINT);
  /* plx = llx + tic_length + onespace;
     prx = urx - onespace; */
  plx = (int)(llx + tic_length + onespace + p.extra_margin * UNITSPERPOINT);
  prx = (int)(urx - onespace - p.extra_margin * UNITSPERPOINT);
  ply = (int)(bly + onespace + otherspace);
  puy = (int)(buy - onespace - otherspace);

  if ( p.elbow_room > 0 ){
    rescalex((UNITSPERPOINT*(p.icon_size+p.elbow_room))/((float)(prx-plx)));
  }

  minxcoord = 10000.0; maxxcoord = - 10000.0;
  minycoord = 10000.0; maxycoord = - 10000.0;
  for ( i = 1; i<=indpt; i++){
    if ( indstack[i].info.xcoord > maxxcoord )
      maxxcoord = indstack[i].info.xcoord;
    if ( indstack[i].info.xcoord < minxcoord )
      minxcoord = indstack[i].info.xcoord;
    if ( indstack[i].info.ycoord > maxycoord )
      maxycoord = indstack[i].info.ycoord;
    if ( indstack[i].info.ycoord < minycoord )
      minycoord = indstack[i].info.ycoord;
  }
  for (i=1; i<=marpt; i++){
    if ( marstack[i].info.xcoord > maxxcoord )
      maxxcoord = marstack[i].info.xcoord;
    if ( marstack[i].info.xcoord < minxcoord )
      minxcoord = marstack[i].info.xcoord;
    if ( marstack[i].info.ycoord > maxycoord )
      maxycoord = marstack[i].info.ycoord;
    if ( marstack[i].info.ycoord < minycoord )
      minycoord = marstack[i].info.ycoord;
  }

  tic_length = (int) ( TICLEN * MIN( urx - llx, buy - bly ) );
  /* onespace is the space from either side to any individual or marriage */
  onespace = (int)(p.icon_size/SQRTPI * UNITSPERPOINT/2 + \
		   DEFAULTINSIDE*MIN(urx - llx, buy - bly ));
  /* onespace + otherspace it the space form the top or bottom 
     to any individual or marriage */
  otherspace = (int)((1.50 + LABELSEP ) * p.label_ptsize * UNITSPERPOINT );
  /* plx = llx + tic_length + onespace;
     prx = urx - onespace; */
  plx = (int)(llx + tic_length + onespace + p.extra_margin * UNITSPERPOINT);
  prx = (int)(urx - onespace - p.extra_margin * UNITSPERPOINT);
  ply = bly + onespace + otherspace;
  puy = buy - onespace - otherspace;
}

float relx(float x)
{
  if ( maxxcoord-minxcoord > 0 )
    return(plx+(prx-plx)*(x-minxcoord)/(maxxcoord-minxcoord));
  else
    return(0.5*(prx+plx));
}

float rely(float y){
  if ( maxycoord-minycoord > 0 )
    return(ply+(puy-ply)*(y-minycoord)/(maxycoord-minycoord));
  else
    return(0.5*(puy+ply));
}

void psedge(const mar *m, const ind *i){
  float x = relx(m->info.xcoord); 
  float y = rely(m->info.ycoord);
  cout << (int) x << ' ' << (int) y << ' ';
  x = relx(i->info.xcoord); 
  y = rely(i->info.ycoord);
  cout << (int) x << ' ' << (int) y << " edge" << endl;
}

void psdotmar(const mar *m)
{ 
  float x = relx(m->info.xcoord);
  float y = rely(m->info.ycoord);
  cout << (int) x << ' ' << (int) y << " dot" << endl;
}


void rgb_icon(const Plotparm &p, const int i)
{
  cout << setprecision(4) << (indstack[i].info.r/255.0) << ' '
      << (indstack[i].info.g/255.0) << ' '
      << (indstack[i].info.b/255.0) << ' ' ;
}

void pssquare(float x, float y, const Plotparm &p,int i){
  float r;
  rgb_icon(p, i);
  r = UNITSPERPOINT * p.icon_size / 2.0;
  cout << (int) (x-r) << ' ' << (int) (y-r) << " squ" << endl;
}

void psdiamond(float x, float y, const Plotparm &p, int i){
  float r;
  rgb_icon( p, i);
  r = UNITSPERPOINT * p.icon_size * SQRT_2;
  cout << (int) x << ' ' <<  (int) (y-r) << " dia" << endl;
}

void pscircle(float x, float y, const Plotparm &p, int i)
{
  rgb_icon(p, i);
  cout << (int) x << ' ' << (int) y << " cir" << endl;
}

void ps_put_label(float x, float y, char *s){
  cout << '(' << s << ") " << (int) x << ' ' << (int) y << " tex" << endl;
}


void psframeplot(){
     /* make box with nx tick marks on x-axis and ny tick marks on y-axis */
  cout << "N\n"
      << llx << ' ' << bly << " M\n"
      << llx << ' ' << buy << " L\n"
      << urx << ' ' << buy << " L\n"
      << urx << ' ' << bly << " L\n"
      << llx << ' ' << bly << " L\n"
      << "C Sk" << endl;
}

void psdrawkids(const mar *m){    
  indlist *il;
  for (il = m->kids; il != noindlist; il = il->next)
    psedge(m,il->cur );
}

void drawps(const char *creator, const Plotparm &p)
     /*
   Draws the pedigree as a marriage node graph to the standard output file.

   If ( p.frame == YES ) a frame is drawn.

   If ( p.icons == YES ) individuals are marked with icons.
   If ( p.icons == NO ) individuals are not marked with icons.

   If ( p.title[0] == 0 ) no title appears, otherwise p.title is the plot title.

   p.width is the width of the page in inches.
   p.height is the height of the page in inches 
     (including the title and any legend).
     The plot is centered in a region PAGEWIDTH by PAGEHEIGHT inches.

   p.title_ptsize is the type size for the title in points ( 1pt = 1/72 inch ).
   p.label_ptsize is the type size for all other text on the plot in points.
   p.icon_size is the size in points of the side the square icon (male).
   p.linewidth is the thickness of all lines
      (frame, graph links, icon outlines )in points.
   p.elbow_room is the minimum separation between tokens (approx).
   p.extra_margin is the extra space in points between the plotted 
      individuals and marriagess and the sides of the box -- default 0.0

*/
{
  int i;
  float ix, iy, iiy;
  mar *m;

  float delta;

  bckpcoords bak;
  if(p.elbow_room > 0)
    bak.copy();

  openplot(creator, p);

  if (p.frame) psframeplot();

  for (i=1; i<=marpt; i++){
    m = &marstack[i];
    if(m->info.flag != GONE){
      psedge(m,m->pa);
      psedge(m,m->ma);
      psdrawkids(m);
      psdotmar(m);
      cout <<"Sk\n";
    } 
  }
  
  for ( i = 1; i<=indpt; i++)
    if ( p.icons == YES && indstack[i].info.flag !=GONE ){
      ix = relx(indstack[i].info.xcoord);
      iy = rely(indstack[i].info.ycoord);
      
      if (indstack[i].info.sex == FEMALE && indstack[i].info.flag == UP)
	pscircle(ix,iy,p,i);
      else if (indstack[i].info.sex == MALE && indstack[i].info.flag == UP)
	pssquare(ix,iy,p,i);
      else if(indstack[i].info.sex == UNKNOWN && indstack[i].info.flag == UP)
	psdiamond(ix,iy,p,i);
      
      if ( p.ids == YES && indstack[i].info.id[0] ){
	if (indstack[i].info.sex == UNKNOWN){
	  delta  = ( LABELSEP * p.label_ptsize +  SQRT_2 * p.icon_size )\
	    * UNITSPERPOINT;
	}else{
	  delta  = ( LABELSEP * p.label_ptsize + p.icon_size / SQRTPI )\
	    * UNITSPERPOINT;
	}
	iiy  = iy + delta;
	ps_put_label(ix,iiy,indstack[i].info.id);
      }
      
      if ( p.labels == YES && indstack[i].info.label[0] ){
	if (indstack[i].info.sex == UNKNOWN){
	  delta =((0.75+LABELSEP)* p.label_ptsize + SQRT_2 * p.icon_size )\
	    * UNITSPERPOINT;
	}else{
	  delta  =((0.75+LABELSEP)* p.label_ptsize + p.icon_size / SQRTPI )\
	    * UNITSPERPOINT;
	}
	iiy  = iy - delta;
	ps_put_label(ix,iiy,indstack[i].info.label);
      }
      
    }

  cout <<"showpage\n"
      << "%%Trailer\n"
      << "grestore\n"
      << "end\n"
      << "%%EOF" << endl;
  if(p.elbow_room >0)
    bak.unset();
}

void drawps(ofstream &out,const char *creator, const Plotparm &p){

  if(out.is_open())
    cout.rdbuf(out.rdbuf());

  drawps(creator, p);
}
